﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web.Services.Protocols;
using System.Reflection;
using System.Xml;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private XmlNode node;
        private XmlDocument xdoc = new XmlDocument();
        private string reportfile = ""; 

        public Form1()
        {
            InitializeComponent();

            Assembly a = Assembly.GetEntryAssembly();
            reportfile = Path.GetDirectoryName(a.Location) + @"\ReportXML.xml";
        }

        private void ReportBtn_Click(object sender, EventArgs e)
        {
            SoapHttpClientProtocol IATSReportLink = new global::WindowsFormsApplication1.IATSReportLink.ReportLink();
            foreach (MethodInfo method in IATSReportLink.GetType().GetMethods())
            {
                if (isWebServiceMethod(method))
                {
                    if (((method.GetCustomAttributes(typeof(SoapDocumentMethodAttribute), false))[0] as SoapDocumentMethodAttribute).RequestElementName == "GetCreditCardJournalCSVV1")
                    {
                        object[] parameters = new object[] { AgentCode.Text, Password.Text, From.Value, CustomerIP.Text };
                        xdoc.LoadXml((method.Invoke(IATSReportLink, parameters) as XmlNode).OuterXml);
                        node = xdoc.SelectSingleNode("IATSRESPONSE/FILE");
                        node.InnerText = System.Text.Encoding.ASCII.GetString(Convert.FromBase64String(node.InnerText)).Trim();
                        xdoc.Save(reportfile);
                        ReportMessage.Navigate(reportfile);

                    }
                }
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (File.Exists(reportfile))
                File.Delete(reportfile);
        }

        private static bool isWebServiceMethod(MemberInfo pMethodInfo)
        {
            return (Attribute.GetCustomAttribute(pMethodInfo, typeof(System.Web.Services.Protocols.SoapDocumentMethodAttribute), false) != null ||
             Attribute.GetCustomAttribute(pMethodInfo, typeof(System.Web.Services.Protocols.SoapRpcMethodAttribute), false) != null);
        }
    }
}
